# @api private
class harbor::config (
  $cfg_version,
  $hostname,
  $ui_url_protocol,
  $max_job_workers,
  $customize_crt,
  $ssl_cert,
  $ssl_cert_key,
  $secretkey_path,
  $admiral_url,
  $log_rotate_count,
  $log_rotate_size,
  $http_proxy,
  $https_proxy,
  $no_proxy,
  $email_identity,
  $email_server,
  $email_server_port,
  $email_username,
  $email_password,
  $email_from,
  $email_ssl,
  $email_insecure,
  $harbor_admin_password,
  $auth_mode,
  $ldap_url,
  $ldap_searchdn,
  $ldap_search_pwd,
  $ldap_basedn,
  $ldap_filter,
  $ldap_uid,
  $ldap_scope,
  $ldap_timeout,
  $ldap_verify_cert,
  $ldap_group_basedn,
  $ldap_group_filter,
  $ldap_group_gid,
  $ldap_group_scope,
  $ldap_group_admin_dn,
  $self_registration,
  $token_expiration,
  $project_creation_restriction,
  $db_host,
  $db_password,
  $db_port,
  $db_user,
  $redis_host,
  $redis_port,
  $redis_password,
  $redis_db_index,
  $clair_db_host,
  $clair_db_password,
  $clair_db_port,
  $clair_db_username,
  $clair_db,
  $clair_updaters_interval,
  $uaa_endpoint,
  $uaa_clientid,
  $uaa_clientsecret,
  $uaa_verify_cert,
  $uaa_ca_cert,
  $registry_storage_provider_name,
  $registry_storage_provider_config,
  $registry_custom_ca_bundle,
  $reload_config,
  $skip_reload_env_pattern,
){

  assert_private()

  file { '/opt/harbor/harbor.cfg':
    owner   => 'root',
    group   => 'root',
    mode    => '0644',
    content => epp('harbor/harbor.cfg.epp', {
      'cfg_version'                      => $cfg_version,
      'hostname'                         => $hostname,
      'ui_url_protocol'                  => $ui_url_protocol,
      'max_job_workers'                  => $max_job_workers,
      'customize_crt'                    => $customize_crt,
      'ssl_cert'                         => $ssl_cert,
      'ssl_cert_key'                     => $ssl_cert_key,
      'secretkey_path'                   => $secretkey_path,
      'admiral_url'                      => $admiral_url,
      'log_rotate_count'                 => $log_rotate_count,
      'log_rotate_size'                  => $log_rotate_size,
      'http_proxy'                       => $http_proxy,
      'https_proxy'                      => $https_proxy,
      'no_proxy'                         => $no_proxy,
      'email_identity'                   => $email_identity,
      'email_server'                     => $email_server,
      'email_server_port'                => $email_server_port,
      'email_username'                   => $email_username,
      'email_password'                   => $email_password,
      'email_from'                       => $email_from,
      'email_ssl'                        => $email_ssl,
      'email_insecure'                   => $email_insecure,
      'harbor_admin_password'            => $harbor_admin_password,
      'auth_mode'                        => $auth_mode,
      'ldap_url'                         => $ldap_url,
      'ldap_searchdn'                    => $ldap_searchdn,
      'ldap_search_pwd'                  => $ldap_search_pwd,
      'ldap_basedn'                      => $ldap_basedn,
      'ldap_filter'                      => $ldap_filter,
      'ldap_uid'                         => $ldap_uid,
      'ldap_scope'                       => $ldap_scope,
      'ldap_timeout'                     => $ldap_timeout,
      'ldap_verify_cert'                 => $ldap_verify_cert,
      'ldap_group_basedn'                => $ldap_group_basedn,
      'ldap_group_filter'                => $ldap_group_filter,
      'ldap_group_gid'                   => $ldap_group_gid,
      'ldap_group_scope'                 => $ldap_group_scope,
      'ldap_group_admin_dn'              => $ldap_group_admin_dn,
      'self_registration'                => $self_registration,
      'token_expiration'                 => $token_expiration,
      'project_creation_restriction'     => $project_creation_restriction,
      'db_host'                          => $db_host,
      'db_password'                      => $db_password,
      'db_port'                          => $db_port,
      'db_user'                          => $db_user,
      'redis_host'                       => $redis_host,
      'redis_port'                       => $redis_port,
      'redis_password'                   => $redis_password,
      'redis_db_index'                   => $redis_db_index,
      'clair_db_host'                    => $clair_db_host,
      'clair_db_password'                => $clair_db_password,
      'clair_db_port'                    => $clair_db_port,
      'clair_db_username'                => $clair_db_username,
      'clair_db'                         => $clair_db,
      'clair_updaters_interval'          => $clair_updaters_interval,
      'uaa_endpoint'                     => $uaa_endpoint,
      'uaa_clientid'                     => $uaa_clientid,
      'uaa_clientsecret'                 => $uaa_clientsecret,
      'uaa_verify_cert'                  => $uaa_verify_cert,
      'uaa_ca_cert'                      => $uaa_ca_cert,
      'registry_storage_provider_name'   => $registry_storage_provider_name,
      'registry_storage_provider_config' => $registry_storage_provider_config,
      'registry_custom_ca_bundle'        => $registry_custom_ca_bundle,
      'reload_config'                    => $reload_config,
      'skip_reload_env_pattern'          => $skip_reload_env_pattern,
    }),
  }

}
